/*
 * Get a random digit string
 *
 * Copyright (C) 1999, <okir@caldera.de>
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <sys/time.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>

#include "skey.h"

static void	get_random_simple(char *buffer, unsigned int len);

void
get_random_digits(char *buffer, unsigned int len)
{
#ifdef DEVRANDOM_PATH
	unsigned char	temp[32];
	int		n, fd;

	if ((fd = open(DEVRANDOM_PATH, O_RDONLY)) >= 0) {
		buffer[len] = '\0';
		while (len) {
			n = read(fd, temp, sizeof(temp));
			while (n && len)
				buffer[--len] = '0' + (temp[--n] % 10);
		}
		close(fd);
		return;
	}
#endif
	get_random_simple(buffer, len);
}

static void
get_random_simple(char *buffer, unsigned int len)
{
	struct timeval	tv;
	unsigned long	val;
	unsigned int	i;

	gettimeofday(&tv, NULL);

	val = tv.tv_usec;
	for (i = 0; i < len; i++) {
		if (i == 6)
			val = tv.tv_sec;
		*buffer++ = '0' + (val % 10);
		val /= 10;
	}
	*buffer++ = '\0';
}
